#include <iostream>
#include <list>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>
#include <deque>
#include <map>


#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <assert.h>

using namespace std;
#include "d0s_pqe.hh"


/*============================

   S T A R T E D _ U S I N G

 =============================*/
void hsh_tbl::started_using(void)
{

  assert(in_use == false);
  in_use = true;
  
} /* end of function started_using */

/*===========================

   D O N E _ U S I N G

 =============================*/
void hsh_tbl::done_using(void)
{
  in_use = false;

}/* end of function done_using */

/*========================================

     C H A N G E _ M A R K E R

========================================*/
void hsh_tbl::change_marker(void)
{
  assert(!in_use);
  if (marker >= MAX_MARKER) {
    marker = 1;
    for (uint i=0; i < table.size();i++)
      table[i] = 0;
    return;
  }
  marker++;

} /* end of function change_marker */
/*=========================

     I N I T

==========================*/
void hsh_tbl::init(int nelems)

{ marker = 1;
  table.clear();
  table.assign(nelems,0);
  in_use = false;
} /* end of function init */



/*======================

     C L E A N

========================*/
void hsh_tbl::clean()

{ marker = 1;
  for (uint i=0; i < table.size(); i++)
     table[i]=0;
} /* end of function clean */



/*========================================

     A D D _ E L E M

  The function allocates memory
  for one more elem.
========================================*/
void hsh_tbl::add_elem(void)
{
  table.push_back(marker);

} /* end of function add_elem */


/*==================

     S I Z E

===================*/
int hsh_tbl::size(void)
{
  return(table.size());

} /* end of function add_elem */


